SystemOrganization addCategory: #'MC2-OmniBrowser-Browsers'!
SystemOrganization addCategory: #'MC2-OmniBrowser-Commands'!
SystemOrganization addCategory: #'MC2-OmniBrowser-Definitions'!
SystemOrganization addCategory: #'MC2-OmniBrowser-Filters'!
SystemOrganization addCategory: #'MC2-OmniBrowser-Nodes'!
SystemOrganization addCategory: #'MC2-OmniBrowser-Panels'!

!MDDefinitionVariant methodsFor: '*mc2-omnibrowser' stamp: 'cwp 10/16/2009 23:18'!
definition
	^ (element handleWith: MDDefinitionHandler new)
		variant: self;
		yourself! !

!MDDefinitionVariant methodsFor: '*mc2-omnibrowser' stamp: 'cwp 7/26/2008 16:39'!
name
	^ properties name ifNil: [self element printString]! !

MDElementHandler subclass: #MDDefinitionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

!MDDefinitionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 23:13'!
handleClass: aClassElement
	^ MDClassDefinition new! !

!MDDefinitionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 23:15'!
handleClassInstVar: anElement
	^ MDEmptyDefinition new! !

!MDDefinitionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 23:15'!
handleClassVar: anElement
	^ MDEmptyDefinition new! !

!MDDefinitionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 23:12'!
handleElement: anElement
	^ MDVariantDefinition new! !

!MDDefinitionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 23:15'!
handleInstVar: anElement
	^ MDEmptyDefinition new! !

!MDDefinitionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 23:16'!
handleMethod: anElement
	^ MDMethodDefinition new! !

!MDDefinitionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 23:16'!
handlePoolImport: anElement
	^ MDEmptyDefinition new! !

OBFilter subclass: #MDMemoFilter
	instanceVariableNames: 'ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Filters'!

!MDMemoFilter methodsFor: 'as yet unclassified' stamp: 'cwp 6/11/2008 07:42'!
ancestryOf: parents includes: aHashstamp
	| grandParents |
	grandParents := parents
		inject: Set new
		into:
			[:set :hashstamp |
			set addAll: (ancestry at: hashstamp ifAbsentPut: [#()]).
			set].
	grandParents isEmpty ifTrue: [^ false].
	^ (grandParents includes: aHashstamp) 
		or: [self ancestryOf: grandParents includes: aHashstamp]! !

!MDMemoFilter methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:14'!
displayString: aString forParent: parent child: aNode 
	| parents |
	ancestry ifNil: [ ^ aString ].
	parents := (aNode environment 
		historianWithId: aNode memo sliceId
		ifAbsent: [ ^ aString ]) parents.
	(parents includes: aNode memo hashstamp) ifTrue: 
		[ ^ (Text fromString: aString) 
			addAttribute: TextEmphasis italic
			from: 1
			to: aString size ].
	^ (self 
		ancestryOf: parents
		includes: aNode memo hashstamp) 
		ifTrue: [ aString ]
		ifFalse: [ (Text fromString: aString) allBold ]! !

!MDMemoFilter methodsFor: 'as yet unclassified' stamp: 'cwp 6/12/2008 00:07'!
nodesFrom: aCollection forNode: aNode
	ancestry := Dictionary new.
	aCollection do:
		[:node |
		ancestry 
			at: node memo hashstamp
			put: node memo parents].
	^ aCollection! !

OBFilter subclass: #MDSliceIconFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Filters'!

!MDSliceIconFilter methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2010 16:42'!
icon: aSelector forNode: aNode
	| dirty |
	dirty := aNode environment isDirty: aNode slice.
	^ (aNode slice isKindOf: MDUnionSlice)
		ifTrue:
			[dirty
				ifTrue: [#compositeDirty]
				ifFalse: [#blank]]
		ifFalse:
			[dirty
				ifTrue: [#smalltalkDirty]
				ifFalse: [#smalltalkClean]]! !

!MDRemovalVariant methodsFor: '*mc2-omnibrowser' stamp: 'cwp 12/16/2007 23:32'!
definition
	^ MDNullDefinition new! !

OBNode subclass: #MDNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

MDNode subclass: #MDChangeNode
	instanceVariableNames: 'workspace change'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDChangeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:11'!
on: aChange inWorkspace: aWorkspace 
	^ self basicNew 
		initializeWithWorkspace: aWorkspace
		change: aChange! !

!MDChangeNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 14:55'!
initializeWithWorkspace: aWorkspace change: aChange 
	self initialize.
	workspace := aWorkspace.
	change := aChange! !

!MDChangeNode methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 16:39'!
name
	^ change variant name! !

!MDChangeNode methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2010 09:17'!
text
	| class |
	class := change element facade = #smalltalk
		ifTrue: [Smalltalk classNamed: change element theClassName].
	^ TextDiffBuilder
		buildDisplayPatchFrom: change original definition text
		to: change final definition text
		inClass: class! !

MDNode subclass: #MDDiffNode
	instanceVariableNames: 'workspace slice changes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDDiffNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:11'!
on: aSet forSlice: aSlice inWorkspace: aWorkspace 
	^ self basicNew 
		initializeWithWorkspace: aWorkspace
		slice: aSlice
		changes: aSet! !

!MDDiffNode methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:38'!
changes
	^ changes collect: [:ea | MDChangeNode on: ea inWorkspace: workspace]! !

!MDDiffNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 14:56'!
initializeWithWorkspace: aWorkspace slice: aSlice changes: aSet 
	self initialize.
	workspace := aWorkspace.
	slice := aSlice.
	changes := aSet asSortedArray! !

!MDDiffNode methodsFor: 'accessing' stamp: 'cwp 5/24/2008 21:57'!
slice
	^ slice! !

MDNode subclass: #MDEnvironmentAwareNode
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDEnvironmentAwareNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:52'!
environment
	^ environment! !

!MDEnvironmentAwareNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 14:58'!
initializeWithEnvironment: anEnvironment
	self initialize.
	environment := anEnvironment! !

!MDEnvironmentAwareNode methodsFor: 'accessing' stamp: 'cwp 7/19/2010 23:09'!
repositories
	^ environment repositories collect: 
		[:ea | MDRepositoryNode on: ea inEnvironment: environment]! !

!MDEnvironmentAwareNode methodsFor: 'accessing' stamp: 'cwp 7/19/2010 22:57'!
slices
	^ environment slices collect: [:ea | MDSliceNode on: ea inEnvironment: environment]! !

MDEnvironmentAwareNode subclass: #MDEnvironmentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDEnvironmentNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:11'!
on: anEnvironment
	^ self basicNew initializeWithEnvironment: anEnvironment! !

!MDEnvironmentNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 16:03'!
isEnvironment
	^ true! !

MDEnvironmentAwareNode subclass: #MDMemoNode
	instanceVariableNames: 'memo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDMemoNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:11'!
on: aMemo inEnvironment: anEnvironment 
	^ self basicNew 
		initializeWithEnvironment: anEnvironment
		memo: aMemo! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:50'!
ancestrySelector
	^ #isDescendantOfMemo: ! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:36'!
browse
	| root |
	root := MDSnapshotNode on: self snapshot inEnvironment: environment.
	(MDSnapshotBrowser root: root) 
		name: memo name;
		open.
	! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2007 12:45'!
canBrowse
	^ true! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:05'!
definition
	^ MDMemoDefinition on: memo! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:14'!
historian
	^ self environment historianWithId: memo sliceId! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 15:05'!
initializeWithEnvironment: anEnvironment memo: aMemo 
	self initializeWithEnvironment: anEnvironment.
	memo := aMemo! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:50'!
isDescendantOfMemo: aMemoNode
	^ aMemoNode reference = memo reference! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 23:04'!
isDescendantOfSlice: aSliceNode
	^ memo matchesSlice: aSliceNode slice! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:09'!
isMemo
	^ true! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:23'!
memo
	^ memo! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/11/2007 22:37'!
name
	^ memo name! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2007 22:50'!
reference
	^ memo reference! !

!MDMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 09:37'!
snapshot
	^ self environment store get: self reference! !

MDEnvironmentAwareNode subclass: #MDRepositoryNode
	instanceVariableNames: 'project repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDRepositoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:12'!
on: aRepository inEnvironment: anEnvironment 
	^ self basicNew 
		initializeWithEnvironment: anEnvironment
		repository: aRepository! !

!MDRepositoryNode methodsFor: 'actions' stamp: 'cwp 8/4/2008 21:33'!
browse
	MDRepositoryBrowser openRoot: self.! !

!MDRepositoryNode methodsFor: 'testing' stamp: 'cwp 8/4/2008 21:34'!
canBrowse
	^ true! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 1/8/2010 15:09'!
initializeWithEnvironment: anEnvironment repository: aRepository 
	self initializeWithEnvironment: anEnvironment.
	repository := aRepository.
	! !

!MDRepositoryNode methodsFor: 'testing' stamp: 'cwp 11/20/2007 00:20'!
isDescendantOfProject: aNode
	^ aNode project repositories includes: repository! !

!MDRepositoryNode methodsFor: 'testing' stamp: 'cwp 6/15/2008 20:04'!
isEditable
	^ false! !

!MDRepositoryNode methodsFor: 'testing' stamp: 'cwp 11/20/2007 00:28'!
isRepository
	^ true! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 8/18/2009 02:44'!
memos
	| memos |
	memos := repository memos asArray sort: [:a :b | b <= a].
	^ memos collect: [:ea | MDMemoNode on: ea inEnvironment: environment]! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 11/11/2007 21:55'!
name
	^ repository description! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 9/4/2009 10:03'!
project
	^ project! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 9/4/2009 10:03'!
project: anObject
	project := anObject! !

!MDRepositoryNode methodsFor: 'accessing' stamp: 'cwp 11/20/2007 00:32'!
repository
	^ repository! !

MDEnvironmentAwareNode subclass: #MDSliceNode
	instanceVariableNames: 'project slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDSliceNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:12'!
on: aSlice inEnvironment: anEnvironment 
	^ self basicNew 
		initializeWithEnvironment: anEnvironment
		slice: aSlice! !

!MDSliceNode methodsFor: 'ancestry' stamp: 'cwp 11/12/2007 22:42'!
ancestrySelector
	^ #isDescendantOfSlice: ! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 12/31/2007 15:02'!
definition
	^ MDSliceDefinition on: slice
		! !

!MDSliceNode methodsFor: 'initialize-release' stamp: 'cwp 1/8/2010 15:09'!
initializeWithEnvironment: anEnvironment slice: aSlice 
	self initializeWithEnvironment: anEnvironment.
	slice := aSlice.
	! !

!MDSliceNode methodsFor: 'testing' stamp: 'cwp 11/8/2007 23:38'!
isSlice
	^ true! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 8/18/2009 02:37'!
memos
	| memos |
	memos := environment store memos select: [:ea | ea matchesSlice: slice].
	memos := memos asArray sort: [:a :b | b <= a].
	^ memos collect: [:ea | MDMemoNode on: ea inEnvironment: environment]! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 11/8/2007 22:21'!
name
	^ slice name! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 9/4/2009 09:54'!
project
	^ project! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 9/4/2009 09:54'!
project: anObject
	project := anObject! !

!MDSliceNode methodsFor: 'actions' stamp: 'cwp 8/14/2009 09:58'!
save
	self environment repositories isEmpty ifTrue:
		[OBInformRequest message: 'This project has no repositories'.
		^ nil].
	^ [self environment save: slice]
		on: MDCommentRequest 
		do: [:req | req resume: (OBTextRequest prompt: req messageText)]! !

!MDSliceNode methodsFor: 'accessing' stamp: 'cwp 11/9/2007 01:01'!
slice
	^ slice! !

MDEnvironmentAwareNode subclass: #MDSnapshotNode
	instanceVariableNames: 'snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDSnapshotNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:12'!
on: aSnapshot inEnvironment: anEnvironment 
	^ self basicNew 
		initializeWithEnvironment: anEnvironment
		snapshot: aSnapshot! !

!MDSnapshotNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 15:10'!
initializeWithEnvironment: anEnvironment snapshot: aSnapshot 
	self initializeWithEnvironment: anEnvironment.
	snapshot := aSnapshot.
	! !

!MDSnapshotNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 16:09'!
name
	^ snapshot hashstamp asString! !

!MDSnapshotNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:55'!
versions
	| versions |
	versions := (snapshot getVersionsFrom: environment store) asArray.
	^ (versions collect: [:ea | MDVersionNode on: ea inEnvironment: environment]) sort! !

MDEnvironmentAwareNode subclass: #MDVersionNode
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDVersionNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:12'!
on: aVersion inEnvironment: anEnvironment 
	^ self basicNew 
		initializeWithEnvironment: anEnvironment
		version: aVersion! !

!MDVersionNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2008 18:53'!
<= other
	^ self name <= other name! !

!MDVersionNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2007 22:55'!
definition
	^ version variant definition! !

!MDVersionNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 15:11'!
initializeWithEnvironment: anEnvironment version: aVersion 
	self initializeWithEnvironment: anEnvironment.
	version := aVersion.
! !

!MDVersionNode methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2008 19:08'!
name
	^ version variant name! !

MDNode subclass: #MDInclusionNode
	instanceVariableNames: 'workspace merges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDInclusionNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:12'!
workspace: aWorkspace merges: aCollection 
	^ self basicNew 
		initializeWithWorkspace: aWorkspace
		merges: aCollection! !

!MDInclusionNode methodsFor: 'comparing' stamp: 'cwp 12/16/2007 20:40'!
= other
	^ self == other! !

!MDInclusionNode methodsFor: 'actions' stamp: 'cwp 12/16/2007 20:31'!
applyAll
	merges do: [:ea | ea apply]! !

!MDInclusionNode methodsFor: 'comparing' stamp: 'cwp 12/16/2007 20:40'!
hash
	^ self identityHash! !

!MDInclusionNode methodsFor: 'initialize-release' stamp: 'cwp 1/8/2010 15:12'!
initializeWithWorkspace: aWorkspace merges: aCollection 
	self initialize.
	workspace := aWorkspace.
	merges := (aCollection collect: 
		[ :ea | 
		MDMergeNode 
			on: ea
			inWorkspace: workspace ]) asArray.
	merges sort! !

!MDInclusionNode methodsFor: 'testing' stamp: 'cwp 12/12/2007 23:20'!
isInclusion
	^ true! !

!MDInclusionNode methodsFor: 'navigation' stamp: 'cwp 12/16/2007 20:29'!
merges
	^ merges ! !

MDNode subclass: #MDMergeNode
	instanceVariableNames: 'merge workspace variant isApplied'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDMergeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:12'!
on: aMerge inWorkspace: aWorkspace 
	^ self basicNew 
		initializeWithMerge: aMerge
		workspace: aWorkspace! !

!MDMergeNode methodsFor: 'comparing' stamp: 'cwp 10/25/2008 14:37'!
<= other
	(self isApplied not and: [other isApplied]) ifTrue: [^ true].
	(self isApplied and: [other isApplied not]) ifTrue: [^ false].
	(self isResolved not and: [other isResolved]) ifTrue: [^ true].
	(self isResolved and: [other isResolved not]) ifTrue: [^ false].
	^ self name asString <= other name asString! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 5/22/2008 21:15'!
apply
	variant
		ifNil: [merge applyTo: workspace]
		ifNotNil: [workspace includeVersion: merge remote onConflict: [:l :r | variant]].
	isApplied := true! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 5/22/2008 21:15'!
chooseLocal
	merge chooseLocal.
	variant := nil! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 5/22/2008 21:15'!
chooseRemote
	merge chooseRemote.
	variant := nil! !

!MDMergeNode methodsFor: 'initialize-release' stamp: 'cwp 1/8/2010 15:13'!
initializeWithMerge: aMerge workspace: aWorkspace 
	self initialize.
	merge := aMerge.
	workspace := aWorkspace.
	isApplied := false! !

!MDMergeNode methodsFor: 'testing' stamp: 'cwp 12/16/2007 20:30'!
isApplied
	^ isApplied! !

!MDMergeNode methodsFor: 'testing' stamp: 'cwp 12/11/2007 15:23'!
isMerge
	^ true! !

!MDMergeNode methodsFor: 'testing' stamp: 'cwp 12/17/2007 22:55'!
isResolved 
	^ variant notNil or: [merge isResolved]! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 12/12/2007 22:36'!
loadLocal
	workspace loadVersion: merge local! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 12/12/2007 22:37'!
loadRemote
	workspace loadVersion: merge remote! !

!MDMergeNode methodsFor: 'variant' stamp: 'cwp 12/17/2007 22:34'!
localVariant
	^ merge local variant! !

!MDMergeNode methodsFor: 'public' stamp: 'cwp 5/22/2008 21:15'!
name
	| name |
	name := String streamContents: [:s | merge displayOn: s].
	self isApplied ifTrue: [^ Text string: name attribute: TextEmphasis struckOut].
	self isResolved ifFalse: [^ Text string: name attribute: TextEmphasis bold].
	^ name
! !

!MDMergeNode methodsFor: 'variant' stamp: 'cwp 12/17/2007 22:35'!
remoteVariant
	^ merge remote variant! !

!MDMergeNode methodsFor: 'variant' stamp: 'cwp 12/17/2007 22:42'!
resolutionVariant
	^ variant ifNil: [merge isResolved ifTrue: [merge resolution variant]]
! !

!MDMergeNode methodsFor: 'actions' stamp: 'cwp 5/22/2008 21:15'!
variant: aVariant
	variant := aVariant! !

!MDNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 15:20'!
new
	self shouldNotImplement! !

!MDNode methodsFor: 'testing' stamp: 'cwp 12/13/2007 21:52'!
canBrowse
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 8/16/2009 16:03'!
isEnvironment
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 12/12/2007 23:20'!
isInclusion
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 11/18/2007 00:09'!
isMemo
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 12/11/2007 15:23'!
isMerge
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 11/19/2007 22:52'!
isProject
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 11/20/2007 00:28'!
isRepository
	^ false! !

!MDNode methodsFor: 'testing' stamp: 'cwp 11/8/2007 23:38'!
isSlice
	^ false! !

OBNode subclass: #MDRepositoryMemoNode
	instanceVariableNames: 'repository memo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDRepositoryMemoNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:12'!
on: aMemo inRepository: aRepository 
	^ self basicNew 
		initializeWithMemo: aMemo
		repository: aRepository! !

!MDRepositoryMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:29'!
canBrowse
	^ true! !

!MDRepositoryMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 15:15'!
initializeWithMemo: aMemo repository: aRepository 
	self initialize.
	memo := aMemo.
	repository := aRepository! !

!MDRepositoryMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:22'!
isMemo
	^ true! !

!MDRepositoryMemoNode methodsFor: 'accessing' stamp: 'cwp 11/28/2008 22:29'!
memo
	^ memo! !

!MDRepositoryMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:18'!
name
	^ memo name! !

!MDRepositoryMemoNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2008 22:29'!
repository
	^ repository! !

OBNode subclass: #MDRepositoryRootNode
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Nodes'!

!MDRepositoryRootNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 16:12'!
on: aRepository 
	^ self basicNew initializeWithRepository: aRepository! !

!MDRepositoryRootNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 15:15'!
initializeWithRepository: aRepository 
	self initialize.
	repository := aRepository! !

!MDRepositoryRootNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:22'!
isMemo
	^ false! !

!MDRepositoryRootNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:25'!
memos
	| memos |
	memos := repository memos asArray sort: [:a :b | b <= a].
	^ memos collect: [:ea | MDRepositoryMemoNode on: ea inRepository: repository]! !

!MDRepositoryRootNode methodsFor: 'as yet unclassified' stamp: 'cwp 11/27/2008 23:20'!
name
	^ repository description! !

!OBMorphicIcons methodsFor: '*mc2-omnibrowser-icons' stamp: 'cwp 8/10/2008 18:45'!
compositeDirty
	^  (Form
		extent: 12@12
		depth: 32
		fromArray: #( 0 0 0 0 0 0 4294901760 4294901760 0 0 4294901760 4294901760 0 0 0 0 0 0 0 4294901760 4294901760 4294901760 4294901760 0 0 0 0 0 0 0 0 0 4294901760 4294901760 0 0 0 0 0 0 0 0 0 4294901760 4294901760 4294901760 4294901760 0 0 0 0 0 0 0 4294901760 4294901760 0 0 4294901760 4294901760 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
		offset: 0@0)! !

!OBMorphicIcons methodsFor: '*mc2-omnibrowser-icons' stamp: 'cwp 6/7/2008 13:02'!
monticelloClean
	^ Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 0 0 0 0 0 0 0 0 0 4278190080 4278190080 0 4278190080 4278190080 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 4278190080 4278190080 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0)
	offset: 0@0! !

!OBMorphicIcons methodsFor: '*mc2-omnibrowser-icons' stamp: 'cwp 6/13/2008 20:43'!
monticelloDirty
	^ (Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294901760 4294901760 0 0 4294901760 4294901760 0 0 0 0 0 4278190080 0 4294901760 4294901760 4294901760 4294901760 0 0 0 0 4278190080 4278190080 0 4278190080 4294967295 4294901760 4294901760 0 0 0 4278190080 4278190080 0 0 0 0 4294901760 4294901760 4294901760 4294901760 0 4278190080 4278190080 4278190080 4278190080 4278190080 4294967295 4294901760 4294901760 4294967295 4294967295 4294901760 4294901760 0 4278190080 0 4278190080 0 4278190080 0 4294967295 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 4278190080 0 0)
	offset: 0@0)! !

!OBMorphicIcons methodsFor: '*mc2-omnibrowser-icons' stamp: 'cwp 6/15/2008 12:36'!
smalltalkClean
	^ Form
		extent: 12@12
		depth: 32
		fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190088 4278190088 0 0 4278190088 0 0 4278190088 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 4278190088 0 0 4278190088 0 0 4278190088 4278190088 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
		offset: 0@0! !

!OBMorphicIcons methodsFor: '*mc2-omnibrowser-icons' stamp: 'cwp 6/15/2008 12:37'!
smalltalkDirty
	^ Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 0 4294901760 4294901760 0 0 4294901760 4294901760 0 0 0 0 0 0 0 4294901760 4294901760 4294901760 4294901760 0 0 4278190088 4278190088 0 0 4278190088 0 0 4294901760 4294901760 0 0 0 4278190088 0 0 0 4278190088 0 4294901760 4294901760 4294901760 4294901760 0 0 4278190088 0 0 0 4278190088 4294901760 4294901760 0 4294967295 4294901760 4294901760 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 0 0 0 4278190088 4278190088 0 0 4278190088 0 0 4278190088 4278190088 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0! !

OBDefinitionPanel subclass: #MDVersionPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Panels'!

MDVersionPanel subclass: #MDLocalPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Panels'!

!MDLocalPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:49'!
variant
	^ node localVariant! !

MDVersionPanel subclass: #MDRemotePanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Panels'!

!MDRemotePanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:49'!
variant
	^ node remoteVariant! !

MDVersionPanel subclass: #MDResolutionPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Panels'!

!MDResolutionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
defaultDefinition
	| variant |
	variant := self variant.
	^ variant
		ifNil: [MDUndefinedDefinition new]
		ifNotNil: [variant definition]! !

!MDResolutionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:49'!
variant
	^ node resolutionVariant.
	! !

!MDVersionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:48'!
defaultDefinition
	^ self variant definition! !

!MDVersionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:27'!
definition: aDefinition
	aDefinition callback: [:variant | self handleVariant: variant].
	super definition: aDefinition! !

!MDVersionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:53'!
handleVariant: aVariant
	node variant: aVariant.
	node announceChangedWith: self.
	^ self variant! !

!MDVersionPanel methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
node: aNode
 	node := aNode.
	node ifNotNil: [self definition: self defaultDefinition]! !

OBBrowser subclass: #MDBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Browsers'!

!MDBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 14:42'!
panels
	^ Array
		with: self navigationPanel
		with: self definitionPanel! !

!MDBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:04'!
defaultBackgroundColor 
	^ (Color r: 0.627 g: 0.69 b: 0.976)! !

MDBrowser subclass: #MDChangesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Browsers'!

!MDChangesBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:36'!
defaultMetaNode
	| diff change |
	diff := OBMetaNode named: 'diff'.
	change := OBMetaNode named: 'change'.
	diff - #changes -> change.
	^ diff! !

!MDChangesBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:49'!
paneCount
	^ 1! !

!MDChangesBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 21:55'!
titleForRoot: aNode
	^ 'Changes for ', aNode slice name! !

MDBrowser subclass: #MDConflictBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Browsers'!

!MDConflictBrowser class methodsFor: 'configuration' stamp: 'cwp 5/22/2008 21:15'!
defaultMetaNode
	| root merge |
	root := OBMetaNode named: 'inclusion'.
	merge := OBMetaNode named: 'merge'.
	root - #merges -> merge.
	^ root! !

!MDConflictBrowser class methodsFor: 'opening' stamp: 'jf 9/8/2009 16:31'!
handleRequest: aRequest
	| root |
	root := MDInclusionNode 
					workspace: aRequest workspace 
					merges: aRequest merges.
	(self root: root) open! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:45'!
localPanel
	^ MDLocalPanel new! !

!MDConflictBrowser class methodsFor: 'configuration' stamp: 'cwp 12/9/2007 10:58'!
paneCount
	^ 1! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:42'!
panels
	^ Array
		with: self navigationPanel
		with: self remotePanel
		with: self localPanel
		with: self resolutionPanel! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:45'!
remotePanel	
	^ MDRemotePanel new! !

!MDConflictBrowser class methodsFor: 'panels' stamp: 'cwp 12/9/2007 10:46'!
resolutionPanel
	^ MDResolutionPanel new! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 10:58'!
buildOn: aBuilder
	^ aBuilder window: self with: 
		[aBuilder horizontalGroupWith:
			[panels first buildOn: aBuilder.
			panels second buildOn: aBuilder].
		aBuilder horizontalGroupWith:
			[panels third buildOn: aBuilder.
			panels fourth buildOn: aBuilder]]! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:23'!
cmdApplyAll
	^ MDCmdApplyAll! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:27'!
cmdChooseLocal
	^ MDCmdChooseLocal! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:08'!
cmdChooseRemote
	^ MDCmdChooseRemote! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 19:58'!
cmdIncludeResolution
	^ MDCmdApplyResolution! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:21'!
cmdLoadLocal
	^ MDCmdLoadLocal! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:31'!
cmdLoadRemote
	^ MDCmdLoadRemote! !

!MDConflictBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 23:59'!
initialExtent
	^ 604@423! !

MDBrowser subclass: #MDEnvironmentBrowser
	instanceVariableNames: 'lastRefresh needsRefresh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Browsers'!

!MDEnvironmentBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2010 17:05'!
defaultMetaNode
	| environment slice repository memo |
	environment := OBMetaNode named: 'environment'.
	slice := OBMetaNode named: 'slice'.
	repository := OBMetaNode named: 'repository'.
	memo := OBMetaNode named: 'memo'.
	
	environment 
		childAt: #slices put: slice;
		childAt: #repositories put: repository;
		addFilter: OBModalFilter new.
		
	repository 
		childAt: #memos put: memo;
		addFilter: MDMemoFilter new.
		
	slice 
		childAt: #memos put: memo;
		addFilter: MDSliceIconFilter new;
		addFilter: MDMemoFilter new.	
	
	^ environment! !

!MDEnvironmentBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2010 17:02'!
defaultRootNode
	^ MDEnvironmentNode on: MDEnvironment default! !

!MDEnvironmentBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2010 17:03'!
paneCount
	^ 3! !

!MDEnvironmentBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2010 17:08'!
registerInOpenMenu
	TheWorldMenu registerOpenCommand: {'Monticello Environment Browser'. {self. #open}}.
! !

!MDEnvironmentBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2010 17:03'!
title
	^ 'Monticello Environment'! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 6/14/2008 01:04'!
cmdAddChangeSetSlice
	^ MDCmdAddChangeSetSlice! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 8/21/2008 19:55'!
cmdAddDirectoryRepository
	^ MDCmdAddDirectoryRepository ! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 11/19/2007 23:58'!
cmdAddFileRepository
	^ MDCmdAddFileRepository! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 11/20/2007 00:37'!
cmdAddMemoryRepository
	^ MDCmdAddMemoryRepository ! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 5/27/2008 20:08'!
cmdAddPackageInfoSlice
	^ MDCmdAddPackageInfoSlice! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 6/14/2008 17:20'!
cmdAddToUnionSlice
	^ MDCmdAddToUnionSlice! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 12/13/2007 21:42'!
cmdBrowse
	^ MDCmdBrowse! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 4/4/2008 21:13'!
cmdFileoutSnapshot
	^ MDCmdFileoutSnapshot! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 21:24'!
cmdIncludeSnapshot
	^ MDCmdIncludeSnapshot! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 11/18/2007 00:22'!
cmdLoadSnapshot
	^ MDCmdLoadSnapshot! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 11/23/2008 17:00'!
cmdNilPrimary
	^ MDCmdNilPrimary! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 01:09'!
cmdPullFromRepository
	^ MDCmdPullFromRepository! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 01:10'!
cmdPushToRepository
	^ MDCmdPushToRepository! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 11/20/2007 00:32'!
cmdRemoveRepository
	^ MDCmdRemoveRepository! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 11/19/2007 23:33'!
cmdRemoveSlice
	^ MDCmdRemoveSlice! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 11/23/2008 16:22'!
cmdRenamePrimary
	^ MDCmdRenamePrimary! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 11/8/2007 23:00'!
cmdSaveSlice
	^ MDCmdSaveSlice! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 00:43'!
cmdSaveSnapshot
	^ MDCmdSaveSnapshot! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 5/24/2008 20:55'!
cmdShowChanges
	^ MDCmdShowChanges! !

!MDEnvironmentBrowser methodsFor: 'commands' stamp: 'cwp 12/23/2007 00:34'!
cmdSyncRepository
	^ MDCmdSyncRepository! !

!MDEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2010 17:03'!
initialExtent
	^ 500@300! !

!MDEnvironmentBrowser methodsFor: 'morphic' stamp: 'cwp 7/19/2010 22:51'!
initialize
	super initialize.
	needsRefresh := false.
	! !

!MDEnvironmentBrowser methodsFor: 'updating' stamp: 'cwp 7/28/2008 19:41'!
noteAnnouncement: anAnnouncement
	needsRefresh := true! !

!MDEnvironmentBrowser methodsFor: 'updating' stamp: 'cwp 7/20/2010 09:17'!
noteElementChange: ann
	ann element facade = #monticello ifTrue:
		[self noteAnnouncement: ann]! !

!MDEnvironmentBrowser methodsFor: 'updating' stamp: 'cwp 7/26/2008 18:10'!
projects
	self subclassResponsibility! !

!MDEnvironmentBrowser methodsFor: 'updating' stamp: 'jf 11/19/2009 16:55'!
register
	self root environment announcer
		observe: MDSliceTouched
		send: #noteAnnouncement:
		to: self.
	self root environment announcer
		observe: MDElementChange
		send: #noteElementChange:
		to: self.! !

!MDEnvironmentBrowser methodsFor: 'morphic' stamp: 'cwp 7/26/2008 18:17'!
stepAt: milliseconds in: aSystemWindow
	needsRefresh ifTrue:
		[self signalRefresh.
		needsRefresh := false]! !

!MDEnvironmentBrowser methodsFor: 'updating' stamp: 'jf 11/19/2009 16:56'!
unregister
	self root environment announcer unsubscribe: self! !

!MDEnvironmentBrowser methodsFor: 'morphic' stamp: 'cwp 3/9/2008 22:04'!
wantsStepsIn: aSystemWindow
	^ aSystemWindow model == self! !

!MDEnvironmentBrowser methodsFor: 'morphic' stamp: 'cwp 7/26/2008 17:55'!
windowIsClosing
	self unregister! !

MDBrowser subclass: #MDRepositoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Browsers'!

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 11/27/2008 23:19'!
browseRepositoryFile: filename
	| repository root |
	repository := MDFileRepository on: (FileStream fileNamed: filename).
	root := MDRepositoryRootNode on: repository.
	self openRoot: root! !

!MDRepositoryBrowser class methodsFor: 'configuration' stamp: 'cwp 8/4/2008 21:17'!
defaultMetaNode
	| root memo |
	root := OBMetaNode named: 'root'.
	memo := OBMetaNode named: 'memo'.
	
	root - #memos -> memo.
	^ root! !

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 8/4/2008 21:42'!
extension
	^ 'mcr'! !

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 8/4/2008 21:43'!
fileReaderServicesForFile: fileName suffix: suffix
	^({ self extension. '*' } includes: suffix)
		ifTrue: [ self services ]
		ifFalse: [#()].
! !

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 8/4/2008 21:49'!
initialize
	FileList registerFileReader: self! !

!MDRepositoryBrowser class methodsFor: 'configuration' stamp: 'cwp 8/4/2008 21:19'!
paneCount
	^ 1! !

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 8/4/2008 21:53'!
serviceBrowseRepository
	^ SimpleServiceEntry
		provider: self
		label: 'browse'
		selector: #browseRepositoryFile:
		description: 'browse a repository'! !

!MDRepositoryBrowser class methodsFor: 'file services' stamp: 'cwp 8/4/2008 21:46'!
services
	^ Array with: self serviceBrowseRepository! !

!MDRepositoryBrowser class methodsFor: 'configuration' stamp: 'cwp 8/12/2008 21:04'!
titleForRoot: aRepositoryNode
	^ 'Repository - ', aRepositoryNode name! !

!MDRepositoryBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 21:23'!
cmdBrowse
	^ MDCmdBrowse! !

!MDRepositoryBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 21:23'!
cmdFileoutSnapshot
	^ MDCmdFileoutSnapshot! !

!MDRepositoryBrowser methodsFor: 'commands' stamp: 'cwp 8/4/2008 21:26'!
cmdSaveSnapshot
	^ MDCmdSaveSnapshot! !

MDBrowser subclass: #MDSnapshotBrowser
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Browsers'!

!MDSnapshotBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2008 18:35'!
defaultMetaNode
	| snapshot version |
	snapshot := OBMetaNode named: 'snapshot'.
	version := OBMetaNode named: 'version'.
	snapshot - #versions -> version.
	^ snapshot! !

!MDSnapshotBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2008 18:53'!
paneCount
	^ 1! !

!MDSnapshotBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 16:09'!
defaultLabel
	^ name ifNil: [self root name]! !

!MDSnapshotBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
name: aString
	name := aString! !

!MDPackageInfoSlice methodsFor: '*mc2-omnibrowser-accessing' stamp: 'cwp 7/19/2010 23:07'!
properties
	^ MDPropertyDictionary new
		name: package name;
		yourself! !

OBDefinition subclass: #MDDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

!MDDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2007 13:35'!
isEditable
	^ false! !

MDDefinition subclass: #MDNullDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

!MDNullDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 21:40'!
callback: aBlock! !

!MDNullDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 23:33'!
text
	^ '-- null --'! !

MDDefinition subclass: #MDPropertiesDefintion
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

MDPropertiesDefintion subclass: #MDMemoDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

!MDMemoDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:31'!
properties
	^ object properties copy
		removeKey: #initials ifAbsent: [];
		removeKey: #ordinal ifAbsent: [];
		removeKey: #comment ifAbsent: [];
		removeKey: #sliceName ifAbsent: [];
		yourself! !

!MDMemoDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:31'!
text
	^ String streamContents: 
		[:stream |
		self printPropertiesOn: stream.
		stream cr.
		object properties comment ifNotNilDo: [:c | stream nextPutAll: c]]! !

MDPropertiesDefintion subclass: #MDProjectDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

!MDProjectDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 16:02'!
timestamp
	^ nil! !

!MDPropertiesDefintion class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 15:17'!
on: anObject 
	^ self new initializeWithObject: anObject! !

!MDPropertiesDefintion methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2010 15:17'!
initializeWithObject: anObject 
	self initialize.
	object := anObject! !

!MDPropertiesDefintion methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 14:46'!
printPropertiesOn: aStream
	self propertiesDo: 
		[:key :value |
		aStream 
			nextPutAll: key asString;
			nextPut: $:;
			space;
			print: value;
			cr].
! !

!MDPropertiesDefintion methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:31'!
properties
	^ object properties! !

!MDPropertiesDefintion methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
propertiesDo: aBlock
	| dict |
	self timestamp ifNotNilDo: [:ts | aBlock value: #timestamp value: ts].
	dict := self properties.
	dict keys asSortedArray do: [:key | aBlock value: key value: (dict at: key)]! !

!MDPropertiesDefintion methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 14:46'!
text
	^ String streamContents: [:stream | self printPropertiesOn: stream]
			! !

!MDPropertiesDefintion methodsFor: 'accessing' stamp: 'cwp 12/31/2007 15:34'!
timestamp
	^ object timestamp! !

MDPropertiesDefintion subclass: #MDSliceDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

MDPropertiesDefintion subclass: #MDVariantDefinition
	instanceVariableNames: 'callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

MDVariantDefinition subclass: #MDClassDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
accept: aText notifying: aRequestor
	
	| variant |
	variant := self parse: aText notifying: aRequestor.
	variant ifNil: [^ false].
	object := callback value: variant.
	^ true! !

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2008 23:48'!
formatFromSelector: aSelector
	aSelector = #weakSubclass: ifTrue: [^ #weak].
	aSelector = #variableSubclass: ifTrue: [^ #variable].
	aSelector = #variableByteSubclass: ifTrue: [^ #bytes].
	aSelector = #variableWordSubclass: ifTrue: [^ #words].
	^ #normal! !

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
formatSelector
	| format |
	format := self properties format.
	format = #weak ifTrue: [^ 'weakSubclass:' ].
	format = #variable ifTrue: [^ 'variableSubclass:'].
	format = #bytes ifTrue: [^ 'variableByteSubclass:'].
	format = #words ifTrue: [^ 'variableWordSubclass:'].
	^ 'subclass:'! !

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
parse: aText notifying: aRequestor
	| tokens element variant |
	tokens := Scanner new scanTokens: aText.
	self verify: tokens notifying: aRequestor ifFail: [^ nil].
	element := MDClassElement className: tokens third.
	variant := MDDefinitionVariant forElement: element.
	variant properties superclassName: tokens first.
	variant properties category: tokens fifth.
	variant properties format: (self formatFromSelector: tokens second).
	^ variant! !

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
text
	| properties |
	properties := self properties.
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: properties superclassName;
			space;
			nextPutAll: self formatSelector;
			space;
			nextPutAll: self variant element theClassName;
			crtab;
			nextPutAll: 'category: ''';
			nextPutAll: properties category;
			nextPut: $']! !

!MDClassDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2008 23:15'!
verify: tokens notifying: aRequestor ifFail: aBlock
	tokens size = 5 ifFalse: aBlock.
	tokens first isSymbol ifFalse: aBlock.
	(#(subclass: weakSubclass: variableSubclass: variableByteSubclass: variableWordSubclass:) 		includes: tokens second) ifFalse: aBlock.
	tokens third isSymbol ifFalse: aBlock.
	tokens fourth = #category: ifFalse: aBlock.
	tokens fifth isString ifFalse: aBlock.! !

MDVariantDefinition subclass: #MDEmptyDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

!MDEmptyDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 22:14'!
callback: aBlock! !

!MDEmptyDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 00:33'!
text
	^ '-- present --'! !

MDVariantDefinition subclass: #MDMethodDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

!MDMethodDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:32'!
text
	^ self properties source asText makeSelectorBold! !

!MDMethodDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
variantWithSource: aText
	
	| new |
	new := MDDefinitionVariant forElement: self variant element.
	new properties
		category: self variant properties category;
		initials: Utilities authorInitials;
		source: aText asString;
		timeStamp: MDTimestamp now.
	^ new! !

!MDMethodDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 21:15'!
verify: aText notifying: aRequestor ifFail: aBlock
	| class |
	class := self elementClass.
	class compilerClass new 
		compile: aText 
		in: class 
		notifying: aRequestor 
		ifFail: aBlock.
	! !

!MDVariantDefinition class methodsFor: 'adapting' stamp: 'cwp 10/16/2009 23:19'!
adapt: anElement
	^ anElement handleWith: MDDefinitionHandler new! !

!MDVariantDefinition methodsFor: 'editing' stamp: 'cwp 5/22/2008 21:15'!
accept: aText notifying: aRequestor
	
	self verify: aText notifying: aRequestor ifFail: [^ false].
	object := callback value: (self variantWithSource: aText).
	^ true! !

!MDVariantDefinition methodsFor: 'editing' stamp: 'cwp 5/22/2008 21:15'!
callback: aBlock
	callback := aBlock! !

!MDVariantDefinition methodsFor: 'editing' stamp: 'cwp 12/31/2007 16:31'!
elementClass
	^ Smalltalk at: self variant element theClassName ifAbsent: [Object]! !

!MDVariantDefinition methodsFor: 'testing' stamp: 'cwp 12/31/2007 16:31'!
isEditable
	^ callback notNil! !

!MDVariantDefinition methodsFor: 'accessing' stamp: 'cwp 12/31/2007 16:17'!
timestamp
	^ nil! !

!MDVariantDefinition methodsFor: 'accessing' stamp: 'cwp 12/31/2007 15:32'!
variant
	^ object! !

!MDVariantDefinition methodsFor: 'accessing' stamp: 'cwp 5/22/2008 21:15'!
variant: aVariant
	object := aVariant! !

!MDVariantDefinition methodsFor: 'accessing' stamp: 'cwp 7/23/2008 07:30'!
variantWithSource: aByteString 
	^ object! !

!MDVariantDefinition methodsFor: 'editing' stamp: 'cwp 12/31/2007 16:32'!
verify: aText notifying: aRequestor ifFail: aBlock
! !

MDDefinition subclass: #MDUndefinedDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Definitions'!

!MDUndefinedDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2007 21:43'!
callback: aBlock! !

OBCommand subclass: #MDCmdAddRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

MDCmdAddRepository subclass: #MDCmdAddDirectoryRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdAddDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2008 19:54'!
createRepository
	^ (OBTextRequest prompt: 'Directory name?')
		ifNotNilDo: [:name | MDDirectoryRepository named: name]! !

!MDCmdAddDirectoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2008 19:52'!
label
	^ 'add directory repository...'! !

MDCmdAddRepository subclass: #MDCmdAddFileRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdAddFileRepository methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2007 15:14'!
createRepository
	^ (OBTextRequest prompt: 'Filename?')
		ifNotNilDo: [:name | MDFileRepository named: name]! !

!MDCmdAddFileRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:56'!
label
	^ 'add file repository...'! !

MDCmdAddRepository subclass: #MDCmdAddMemoryRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdAddMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 16:14'!
createRepository
	| name |
	name := OBTextRequest prompt: 'Enter repository name'.
	^ name ifNotNil: [MDMemoryRepository named: name]! !

!MDCmdAddMemoryRepository methodsFor: 'as yet unclassified' stamp: 'cwp 6/7/2008 15:21'!
label
	^ 'add memory repository...'! !

MDCmdAddRepository subclass: #MDCmdAddNetRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdAddNetRepository methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 16:16'!
createRepository
	| host port |
	^ (OBTextRequest prompt: 'host[:port]')
		ifNotNilDo: 
			[:specifier | 
			(specifier includes: $:)
				ifFalse: [MDNetRepository host: specifier]
				ifTrue:
					[host := specifier upTo: $:.
					port := (specifier allButFirst: host size + 1) asNumber.
					MDNetRepository host: host port: port]]! !

!MDCmdAddNetRepository methodsFor: 'as yet unclassified' stamp: 'cwp 1/21/2008 20:27'!
label
	^ 'add network repository...'! !

!MDCmdAddRepository methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2010 17:35'!
execute
	| repository |
	repository := self createRepository.
	repository ifNotNil:
		[target environment addRepository: repository.
		(MDRepositoryNode on: repository inEnvironment: target environment)
			announceCreationWith: requestor]! !

!MDCmdAddRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:50'!
group
	^ #project! !

!MDCmdAddRepository methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2010 17:15'!
isActive
	^ target isEnvironment and: 
		[(target metaNode edgesForNode: target) anySatisfy: [:ea | ea label = 'repositories']]! !

OBCommand subclass: #MDCmdAddSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

MDCmdAddSlice subclass: #MDCmdAddChangeSetSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdAddChangeSetSlice methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2010 09:18'!
execute
	| changeSet slice |
	changeSet := OBChoiceRequest 
		prompt: 'Please choose a change set.'
		labels: (ChangeSet allChangeSets collect: [:ea | ea name])
		values: ChangeSet allChangeSets.
	changeSet ifNotNil:
		[slice := MDChangeSetSlice on: changeSet.
		self ensureFacade: #smalltalk with: [MDSqueakFacade new].
		target environment addSlice: slice.
		(MDSliceNode on: slice inEnvironment: target environment) 
			announceCreationWith: requestor]! !

!MDCmdAddChangeSetSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 00:29'!
label
	^ 'add changeset slice...'! !

MDCmdAddSlice subclass: #MDCmdAddPackageInfoSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdAddPackageInfoSlice methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2010 09:18'!
execute
	| name slice |
	name := OBTextRequest prompt: 'Enter the name of the slice'.
	name ifNotNil: 
		[slice := MDPackageInfoSlice named: name.
		self ensureFacade: #smalltalk with: [MDSqueakFacade new].
		target environment addSlice: slice.
		(MDSliceNode on: slice inEnvironment: target environment) 
			announceCreationWith: requestor]! !

!MDCmdAddPackageInfoSlice methodsFor: 'as yet unclassified' stamp: 'cwp 5/27/2008 20:13'!
label
	^ 'add packageinfo slice...'! !

!MDCmdAddSlice methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2010 09:18'!
ensureFacade: aSymbol with: aBlock 
	| workspace |
	workspace := target environment workspace.
	(workspace hasFacadeNamed: aSymbol) ifFalse: 
		[workspace facadeAt: aSymbol put: aBlock value]! !

!MDCmdAddSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/6/2008 23:18'!
group
	^ #project! !

!MDCmdAddSlice methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2010 17:16'!
isActive
	^ target isEnvironment 
		and: [(requestor isSelected: target) not]
		and: [(target metaNode edgesForNode: target) anySatisfy: [:ea | ea label = 'slices']]! !

OBCommand subclass: #MDCmdAddToUnionSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 2/3/2010 23:11'!
createSlice
	| name slice |
	name := OBTextRequest prompt: 'Enter the name of the slice:'.
	slice := MDUnionSlice name: name.
	target environment addSlice: slice.
	^ slice! !

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:18'!
execute
	| union |
	union := self getSliceFromUser ifNil: [^ self].
	union addSlice: target slice.! !

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:48'!
getSliceFromUser
	| choices slice |
	choices := target project slices select: [:ea | ea isKindOf: MDUnionSlice].
	choices := choices reject: [:ea | ea includesSlice: target slice].
	slice := OBChoiceRequest
		prompt: 'Choose a slice'
		labels: ((choices collect: [:ea | ea name]) copyWithFirst: 'new...')
		values: (choices copyWithFirst: #new)
		lines: #(1).
	^ slice == #new
		ifFalse: [slice]
		ifTrue: [self createSlice]! !

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:26'!
group
	^ #project! !

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:09'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdAddToUnionSlice methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 17:05'!
label
	^ 'add to union slice...'! !

OBCommand subclass: #MDCmdApplyAll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdApplyAll methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 20:33'!
execute
	target applyAll.
	target announceChildrenChangedWith: requestor ! !

!MDCmdApplyAll methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:52'!
group
	^ #all! !

!MDCmdApplyAll methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:22'!
isActive
	^ target isInclusion and: [(requestor isSelected: target) not]! !

!MDCmdApplyAll methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:46'!
isEnabled
	^ target merges allSatisfy: [:ea | ea isResolved]! !

!MDCmdApplyAll methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 23:18'!
label
	^ 'apply all'! !

OBCommand subclass: #MDCmdBrowse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdBrowse methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:44'!
execute
	target browse! !

!MDCmdBrowse methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:54'!
isActive
	^ (requestor isSelected: target) and: [target canBrowse]! !

!MDCmdBrowse methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:44'!
keystroke
	^ $b! !

!MDCmdBrowse methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:35'!
label
	^ 'browse'! !

OBCommand subclass: #MDCmdFileoutSnapshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdFileoutSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 9/8/2009 22:48'!
execute
	| exporter file |
	MDPlatform current
		withCursor: #write
		do:	[file := self openFile.
			[exporter := MDFileOutExporter on: file.
			exporter
				export: target memo
				from: target environment store]
					ensure: [file close]]! !

!MDCmdFileoutSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 4/4/2008 20:31'!
group
	^ #exporting! !

!MDCmdFileoutSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 4/4/2008 20:26'!
isActive
	^ target isMemo and: [requestor isSelected: target]! !

!MDCmdFileoutSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 4/4/2008 20:18'!
label
	^ 'fileout'! !

!MDCmdFileoutSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 4/4/2008 21:17'!
openFile
	^ FileDirectory default forceNewFileNamed: (target memo name, '.st')! !

OBCommand subclass: #MDCmdIncludeSnapshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 09:47'!
execute
	target environment include: target memo! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:54'!
group
	^ #loading! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:53'!
isActive
	^ target isMemo and: [requestor isSelected: target]! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:51'!
keystroke
	^ $i! !

!MDCmdIncludeSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2007 12:50'!
label
	^ 'include'! !

OBCommand subclass: #MDCmdLoadSnapshot
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2009 09:50'!
execute
	target environment load: target memo! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:06'!
group
	^ #loading! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:11'!
isActive
	^ target isMemo and: [requestor isSelected: target]! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:04'!
keystroke
	^ $l! !

!MDCmdLoadSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2007 00:01'!
label
	^ 'load'! !

OBCommand subclass: #MDCmdRemoveRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:31'!
execute
	target project removeRepository: target repository.
	target announceDeletionWith: requestor! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/6/2008 20:54'!
group
	^ #project! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2007 00:31'!
isActive
	^ target isRepository and: [requestor isSelected: target]! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:30'!
keystroke
	^ $x! !

!MDCmdRemoveRepository methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2007 00:33'!
label
	^ 'remove'! !

OBCommand subclass: #MDCmdRemoveSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:39'!
execute
	target project removeSlice: target slice.
	target announceDeletionWith: requestor! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:34'!
group
	^ #project! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:30'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:28'!
keystroke
	^ $x! !

!MDCmdRemoveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:34'!
label
	^ 'remove slice'! !

OBCommand subclass: #MDCmdSaveSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 7/26/2008 18:31'!
execute
	| memo |
	memo := target save.
	memo ifNotNil: 
		[(MDMemoNode on: memo inProject: target project)
			announceCreationWith: requestor].
	target announceChangedWith: requestor! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 00:52'!
group
	^ #saving! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:01'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:37'!
keystroke
	^ $s! !

!MDCmdSaveSlice methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2007 23:00'!
label
	^ 'save'! !

OBCommand subclass: #MDCmdSaveSnapshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdSaveSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 9/8/2009 23:01'!
execute
	| source snapshot versions destination |
	source := target environment store.
	snapshot := (source get: target memo reference) ifNil: [^ self readError].
	versions := snapshot contents collect: [:ea | (source get: ea) ifNil: [^ self readError]].
	destination := MDFileRepository named: target memo name.
	[destination put: target memo.
	destination put: snapshot.
	destination putAll: versions]
		ensure: [destination close]
	! !

!MDCmdSaveSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 00:50'!
group
	^ #exporting! !

!MDCmdSaveSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 00:01'!
isActive
	^ target isMemo and: [requestor isSelected: target]! !

!MDCmdSaveSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2008 23:54'!
label
	^ 'save to file'! !

!MDCmdSaveSnapshot methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 00:39'!
readError
	OBInformRequest message: 'Some data was not available'! !

OBCommand subclass: #MDCmdShowChanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdShowChanges methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 13:22'!
execute
	| node changes |
	changes := MDPlatform current
		withCursor: #wait 
		do: [target environment changesForSlice: target slice].
	changes isEmpty
		ifTrue: 
			[target environment noteClean: target slice]
		ifFalse: 
			[target environment noteDirty: target slice.
			node := MDDiffNode 
				on: changes
				forSlice: target slice
				inWorkspace: target environment workspace.
			MDChangesBrowser openRoot: node]! !

!MDCmdShowChanges methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 20:38'!
isActive
	^ target isSlice and: [requestor isSelected: target]! !

!MDCmdShowChanges methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2008 20:26'!
label
	^ 'show changes...'! !

OBCommand subclass: #MDDirectoryRepositoryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

MDDirectoryRepositoryCommand subclass: #MDCmdNilPrimary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdNilPrimary methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:58'!
execute
	target repository primaryName: nil.
	target announceChangedWith: requestor
	! !

!MDCmdNilPrimary methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 17:07'!
isEnabled
	^ super isEnabled and: [target repository hasPrimaryName]! !

!MDCmdNilPrimary methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:37'!
label
	^ 'use default primary'! !

MDDirectoryRepositoryCommand subclass: #MDCmdRenamePrimary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdRenamePrimary methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:31'!
execute
	| newName |
	newName := OBTextRequest prompt: 'Enter new name:'.
	newName ifNotNil:
		[target repository primaryName: newName.
		target announceChangedWith: requestor].
	! !

!MDCmdRenamePrimary methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:07'!
label
	^ 'rename primary...'! !

!MDDirectoryRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2008 16:45'!
isActive
	^ target isRepository and: [requestor isSelected: target]! !

!MDDirectoryRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'jf 11/8/2009 17:23'!
isEnabled
	^ target repository class == MDDirectoryRepository! !

OBCommand subclass: #MDMergeCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

MDMergeCommand subclass: #MDCmdApplyResolution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdApplyResolution methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 20:11'!
execute
	target apply.
	target announceChangedWith: requestor! !

!MDCmdApplyResolution methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:22'!
group
	^ #choosing! !

!MDCmdApplyResolution methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 22:44'!
isEnabled
	^ target isResolved and: [target isApplied not]! !

!MDCmdApplyResolution methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:40'!
keystroke
	^ $a! !

!MDCmdApplyResolution methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:38'!
label
	^ 'apply resolution'! !

MDMergeCommand subclass: #MDCmdChooseLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:28'!
execute
	target chooseLocal.
	target announceChangedWith: requestor! !

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 22:45'!
isEnabled
	^ target isApplied not! !

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 15:20'!
keystroke
	^ $l! !

!MDCmdChooseLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2007 20:14'!
label
	^ 'choose local'! !

MDMergeCommand subclass: #MDCmdChooseRemote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:09'!
execute
	target chooseRemote.
	target announceChangedWith: requestor! !

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2007 22:45'!
isEnabled
	^ target isApplied not! !

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:07'!
keystroke
	^ $r! !

!MDCmdChooseRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:07'!
label
	^ 'choose remote'! !

MDMergeCommand subclass: #MDCmdLoadLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdLoadLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:25'!
execute
	target loadLocal! !

!MDCmdLoadLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:20'!
group
	^ #loading! !

!MDCmdLoadLocal methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:20'!
label
	^ 'load local'! !

MDMergeCommand subclass: #MDCmdLoadRemote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdLoadRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:32'!
execute
	^ target loadRemote! !

!MDCmdLoadRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:30'!
group
	^ #loading! !

!MDCmdLoadRemote methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:30'!
label
	^ 'load remote'! !

!MDMergeCommand methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2007 22:12'!
group
	^ #choosing! !

!MDMergeCommand methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2007 19:06'!
isActive
	^ target isMerge and: [requestor isSelected: target]! !

OBCommand subclass: #MDSyncCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

MDSyncCommand subclass: #MDCmdPullFromRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdPullFromRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:18'!
execute
	self chooseRepositoryDo: [:other | other pushTo: target repository]! !

!MDCmdPullFromRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:07'!
label
	^ 'pull from...'! !

MDSyncCommand subclass: #MDCmdPushToRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdPushToRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:19'!
execute
	self chooseRepositoryDo: [:other | target repository pushTo: other]! !

!MDCmdPushToRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:06'!
label
	^ 'push to...'! !

MDSyncCommand subclass: #MDCmdSyncRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-OmniBrowser-Commands'!

!MDCmdSyncRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:20'!
execute
	self chooseRepositoryDo: [:other | target repository synchronizeWith: other]! !

!MDCmdSyncRepository methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2007 00:16'!
label
	^ 'sync with...'! !

!MDSyncCommand methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:19'!
chooseRepositoryDo: aBlock
	| choices repository |
	choices := target project repositories copyWithout: target repository.
	repository := OBChoiceRequest 
		prompt: 'Choose a repository'
		labels: (choices collect: [ :ea | ea description ])
		values: choices.
	repository ifNotNil:
		[self waitCursorDuring: [aBlock value: repository]]! !

!MDSyncCommand methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:09'!
group
	^ #sync! !

!MDSyncCommand methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:05'!
isActive
	^ target isRepository and: [requestor isSelected: target]! !

!MDSyncCommand methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2009 02:52'!
isEnabled
	^ target environment repositories anySatisfy: [:ea | ea ~~ target repository]! !

!MDSyncCommand methodsFor: 'as yet unclassified' stamp: 'cwp 8/4/2008 01:13'!
waitCursorDuring: aBlock
	MDPlatform current withCursor: #wait do: aBlock! !

!MDVariant methodsFor: '*mc2-omnibrowser' stamp: 'cwp 7/26/2008 16:39'!
name
	^ self element printString! !
MDRepositoryBrowser initialize!
